Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Classes | Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
Botan::XMSS_WOTS_PublicKey Class Reference

`#include <xmss_wots_publickey.h>`

Inheritance diagram for Botan::XMSS_WOTS_PublicKey:

## Classes
class | TreeSignature

## Public Member Functions
virtual std::string | algo_name () const override
virtual AlgorithmIdentifier | algorithm_identifier () const override
virtual bool | check_key (RandomNumberGenerator &, bool) const override
virtual std::unique_ptr< PK_Ops::Encryption > | create_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::KEM_Encryption > | create_kem_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::Verification > | create_verification_op (const std::string &, const std::string &provider) const override
virtual size_t | estimated_strength () const override
virtual OID | get_oid () const
const wots_keysig_t & | key_data () const
wots_keysig_t & | key_data ()
virtual size_t | key_length () const override
virtual size_t | message_part_size () const
virtual size_t | message_parts () const
| operator const wots_keysig_t & () const
| operator wots_keysig_t & ()
bool | operator!= (const XMSS_WOTS_PublicKey &key)
bool | operator== (const XMSS_WOTS_PublicKey &key)
const secure_vector< uint8_t > & | operator[] (size_t i) const
secure_vector< uint8_t > & | operator[] (size_t i)
virtual std::vector< uint8_t > | public_key_bits () const override
const secure_vector< uint8_t > & | public_seed () const
secure_vector< uint8_t > & | public_seed ()
void | set_key_data (const wots_keysig_t &key_data)
void | set_key_data (wots_keysig_t &&key_data)
void | set_public_seed (const secure_vector< uint8_t > &public_seed)
void | set_public_seed (secure_vector< uint8_t > &&public_seed)
std::vector< uint8_t > | subject_public_key () const
const XMSS_WOTS_Parameters & | wots_parameters () const
| XMSS_WOTS_PublicKey (XMSS_WOTS_Parameters::ots_algorithm_t oid)
| XMSS_WOTS_PublicKey (XMSS_WOTS_Parameters::ots_algorithm_t oid, RandomNumberGenerator &rng)
| XMSS_WOTS_PublicKey (XMSS_WOTS_Parameters::ots_algorithm_t oid, secure_vector< uint8_t > public_seed)
| XMSS_WOTS_PublicKey (XMSS_WOTS_Parameters::ots_algorithm_t oid, secure_vector< uint8_t > &&public_seed, wots_keysig_t &&key)
| XMSS_WOTS_PublicKey (XMSS_WOTS_Parameters::ots_algorithm_t oid, const secure_vector< uint8_t > &public_seed, const wots_keysig_t &key)
| XMSS_WOTS_PublicKey (XMSS_WOTS_Parameters::ots_algorithm_t oid, const secure_vector< uint8_t > &msg, const wots_keysig_t &sig, XMSS_Address &adrs, const secure_vector< uint8_t > &public_seed)

## Protected Member Functions
void | chain (secure_vector< uint8_t > &x, size_t start_idx, size_t steps, XMSS_Address &adrs, const secure_vector< uint8_t > &public_seed)

## Protected Attributes
XMSS_Hash | m_hash
wots_keysig_t | m_key
secure_vector< uint8_t > | m_public_seed
XMSS_WOTS_Parameters | m_wots_params

## Detailed Description

A Winternitz One Time Signature public key for use with Extended Hash-Based Signatures.

Definition at line 32 of file xmss_wots_publickey.h.

## Constructor & Destructor Documentation

Botan::XMSS_WOTS_PublicKey::XMSS_WOTS_PublicKey | ( | XMSS_WOTS_Parameters::ots_algorithm_t | oid | ) |
| inline

Creates a XMSS_WOTS_PublicKey for the signature method identified by oid. The public seed for this key will be initialized with a uniformly random n-byte value, where "n" is the element size of the selected signature method.

Parameters

  oid | Identifier for the selected signature method.

Definition at line 84 of file xmss_wots_publickey.h.

85 : m_wots_params(oid),
86 m_hash(m_wots_params.hash_function_name()) {}
Botan::XMSS_WOTS_PublicKey::m_hash
XMSS_Hash m_hash
Definition: xmss_wots_publickey.h:302
Botan::XMSS_WOTS_PublicKey::m_wots_params
XMSS_WOTS_Parameters m_wots_params
Definition: xmss_wots_publickey.h:301
Botan::XMSS_WOTS_Parameters::hash_function_name
const std::string & hash_function_name() const
Definition: xmss_wots_parameters.h:75

Botan::XMSS_WOTS_PublicKey::XMSS_WOTS_PublicKey | ( | XMSS_WOTS_Parameters::ots_algorithm_t | oid,
|  | RandomNumberGenerator & | rng
| ) |  |
| inline

Creates a XMSS_WOTS_PublicKey for the signature method identified by oid. The public seed for this key will be initialized with a uniformly random n-byte value, where "n" is the element size of the selected signature method.

Parameters

  oid | Identifier for the selected signature method.
  rng | A random number generate used to generate the public seed.

Definition at line 97 of file xmss_wots_publickey.h.

99 : m_wots_params(oid),
100 m_hash(m_wots_params.hash_function_name()),
101 m_public_seed(rng.random_vec(m_wots_params.element_size())) {}
Botan::XMSS_WOTS_PublicKey::m_public_seed
secure_vector< uint8_t > m_public_seed
Definition: xmss_wots_publickey.h:305
Botan::XMSS_WOTS_Parameters::element_size
size_t element_size() const
Definition: xmss_wots_parameters.h:87
Botan::XMSS_WOTS_PublicKey::m_hash
XMSS_Hash m_hash
Definition: xmss_wots_publickey.h:302
Botan::XMSS_WOTS_PublicKey::m_wots_params
XMSS_WOTS_Parameters m_wots_params
Definition: xmss_wots_publickey.h:301
Botan::XMSS_WOTS_Parameters::hash_function_name
const std::string & hash_function_name() const
Definition: xmss_wots_parameters.h:75

Botan::XMSS_WOTS_PublicKey::XMSS_WOTS_PublicKey | ( | XMSS_WOTS_Parameters::ots_algorithm_t | oid,
|  | secure_vector< uint8_t > | public_seed
| ) |  |
| inline

Creates a XMSS_WOTS_PrivateKey for the signature method identified by oid, with a precomputed public seed.

Parameters

  oid | Identifier for the selected signature method.
  public_seed | A precomputed public seed of n-bytes length.

Definition at line 110 of file xmss_wots_publickey.h.

112 : m_wots_params(oid),
113 m_hash(m_wots_params.hash_function_name()),
114 m_public_seed(public_seed) {}
Botan::XMSS_WOTS_PublicKey::m_public_seed
secure_vector< uint8_t > m_public_seed
Definition: xmss_wots_publickey.h:305
Botan::XMSS_WOTS_PublicKey::public_seed
const secure_vector< uint8_t > & public_seed() const
Definition: xmss_wots_publickey.h:201
Botan::XMSS_WOTS_PublicKey::m_hash
XMSS_Hash m_hash
Definition: xmss_wots_publickey.h:302
Botan::XMSS_WOTS_PublicKey::m_wots_params
XMSS_WOTS_Parameters m_wots_params
Definition: xmss_wots_publickey.h:301
Botan::XMSS_WOTS_Parameters::hash_function_name
const std::string & hash_function_name() const
Definition: xmss_wots_parameters.h:75

Botan::XMSS_WOTS_PublicKey::XMSS_WOTS_PublicKey | ( | XMSS_WOTS_Parameters::ots_algorithm_t | oid,
|  | secure_vector< uint8_t > && | public_seed,
|  | wots_keysig_t && | key
| ) |  |
| inline

Creates a XMSS_WOTS_PublicKey for the signature method identified by oid. The public seed will be initialized with a precomputed seed and and precomputed key data which should be derived from a XMSS_WOTS_PrivateKey.

Parameters

  oid | Ident:s/ifier for the selected signature methods.
  public_seed | A precomputed public seed of n-bytes length.
  key | Precomputed raw key data of the XMSS_WOTS_PublicKey.

Definition at line 126 of file xmss_wots_publickey.h.

129 : m_wots_params(oid),
130 m_hash(m_wots_params.hash_function_name()),
131 m_key(std::move(key)),
132 m_public_seed(std::move(public_seed))
133 {}
Botan::XMSS_WOTS_PublicKey::m_public_seed
secure_vector< uint8_t > m_public_seed
Definition: xmss_wots_publickey.h:305
Botan::XMSS_WOTS_PublicKey::public_seed
const secure_vector< uint8_t > & public_seed() const
Definition: xmss_wots_publickey.h:201
Botan::XMSS_WOTS_PublicKey::m_hash
XMSS_Hash m_hash
Definition: xmss_wots_publickey.h:302
Botan::XMSS_WOTS_PublicKey::m_key
wots_keysig_t m_key
Definition: xmss_wots_publickey.h:304
Botan::XMSS_WOTS_PublicKey::m_wots_params
XMSS_WOTS_Parameters m_wots_params
Definition: xmss_wots_publickey.h:301
Botan::XMSS_WOTS_Parameters::hash_function_name
const std::string & hash_function_name() const
Definition: xmss_wots_parameters.h:75

Botan::XMSS_WOTS_PublicKey::XMSS_WOTS_PublicKey | ( | XMSS_WOTS_Parameters::ots_algorithm_t | oid,
|  | const secure_vector< uint8_t > & | public_seed,
|  | const wots_keysig_t & | key
| ) |  |
| inline

Creates a XMSS_WOTS_PublicKey for the signature method identified by oid. The public seed will be initialized with a precomputed seed and and precomputed key data which should be derived from a XMSS_WOTS_PrivateKey.

Parameters

  oid | Identifier for the selected signature methods.
  public_seed | A precomputed public seed of n-bytes length.
  key | Precomputed raw key data of the XMSS_WOTS_PublicKey.

Definition at line 145 of file xmss_wots_publickey.h.

148 : m_wots_params(oid),
149 m_hash(m_wots_params.hash_function_name()),
150 m_key(key),
151 m_public_seed(public_seed)
152 {}
Botan::XMSS_WOTS_PublicKey::m_public_seed
secure_vector< uint8_t > m_public_seed
Definition: xmss_wots_publickey.h:305
Botan::XMSS_WOTS_PublicKey::public_seed
const secure_vector< uint8_t > & public_seed() const
Definition: xmss_wots_publickey.h:201
Botan::XMSS_WOTS_PublicKey::m_hash
XMSS_Hash m_hash
Definition: xmss_wots_publickey.h:302
Botan::XMSS_WOTS_PublicKey::m_key
wots_keysig_t m_key
Definition: xmss_wots_publickey.h:304
Botan::XMSS_WOTS_PublicKey::m_wots_params
XMSS_WOTS_Parameters m_wots_params
Definition: xmss_wots_publickey.h:301
Botan::XMSS_WOTS_Parameters::hash_function_name
const std::string & hash_function_name() const
Definition: xmss_wots_parameters.h:75

Botan::XMSS_WOTS_PublicKey::XMSS_WOTS_PublicKey | ( | XMSS_WOTS_Parameters::ots_algorithm_t | oid,
|  | const secure_vector< uint8_t > & | msg,
|  | const wots_keysig_t & | sig,
|  | XMSS_Address & | adrs,
|  | const secure_vector< uint8_t > & | public_seed
| ) |  |
| inline

Creates a XMSS_WOTS_PublicKey form a message and signature using Algorithm 6 WOTS_pkFromSig defined in the XMSS standard. This overload is used to verify a message using a public key.

Parameters

  oid | WOTSP algorithm identifier.
  msg | A message.
  sig | A WOTS signature for msg.
  adrs | An XMSS_Address.
  public_seed | The public public_seed.

Definition at line 165 of file xmss_wots_publickey.h.

170 : m_wots_params(oid),
171 m_hash(m_wots_params.hash_function_name()),
172 m_key(pub_key_from_signature(msg,
173 sig,
174 adrs,
175 public_seed)),
176 m_public_seed(public_seed)
177 {}
Botan::XMSS_WOTS_PublicKey::m_public_seed
secure_vector< uint8_t > m_public_seed
Definition: xmss_wots_publickey.h:305
Botan::XMSS_WOTS_PublicKey::public_seed
const secure_vector< uint8_t > & public_seed() const
Definition: xmss_wots_publickey.h:201
Botan::XMSS_WOTS_PublicKey::m_hash
XMSS_Hash m_hash
Definition: xmss_wots_publickey.h:302
Botan::XMSS_WOTS_PublicKey::m_key
wots_keysig_t m_key
Definition: xmss_wots_publickey.h:304
Botan::XMSS_WOTS_PublicKey::m_wots_params
XMSS_WOTS_Parameters m_wots_params
Definition: xmss_wots_publickey.h:301
Botan::XMSS_WOTS_Parameters::hash_function_name
const std::string & hash_function_name() const
Definition: xmss_wots_parameters.h:75

## Member Function Documentation

virtual std::string Botan::XMSS_WOTS_PublicKey::algo_name | ( |  | ) | const
| inline override virtual

Get the name of the underlying public key scheme.

Returns
  name of the public key scheme

Implements Botan::Public_Key.

Definition at line 234 of file xmss_wots_publickey.h.

Referenced by Botan::XMSS_WOTS_Addressed_PublicKey::algo_name(), Botan::XMSS_WOTS_PrivateKey::create_signature_op(), and create_verification_op().

235 {
236 return m_wots_params.name();
237 }
Botan::XMSS_WOTS_Parameters::name
const std::string & name() const
Definition: xmss_wots_parameters.h:67
Botan::XMSS_WOTS_PublicKey::m_wots_params
XMSS_WOTS_Parameters m_wots_params
Definition: xmss_wots_publickey.h:301

virtual AlgorithmIdentifier Botan::XMSS_WOTS_PublicKey::algorithm_identifier | ( |  | ) | const
| inline override virtual

Returns
  X.509 AlgorithmIdentifier for this key

Implements Botan::Public_Key.

Definition at line 239 of file xmss_wots_publickey.h.

Referenced by Botan::XMSS_WOTS_Addressed_PublicKey::algorithm_identifier().

240 {
241 throw Not_Implemented("No AlgorithmIdentifier available for XMSS-WOTS.");
242 }

void Botan::XMSS_WOTS_PublicKey::chain | ( | secure_vector< uint8_t > & | x,
|  | size_t | start_idx,
|  | size_t | steps,
|  | XMSS_Address & | adrs,
|  | const secure_vector< uint8_t > & | public_seed
| ) |  |
| protected

Algorithm 2: Chaining Function.

Takes an n-byte input string and transforms it into a the function result iterating the cryptographic hash function "F" steps times on the input x using the outputs of the PRNG "G".

Parameters

  [out] | x | An n-byte input string, that will be transformed into the chaining function result.
  | start_idx | The start index.
  | steps | A number of steps.
  | adrs | An OTS Hash Address.
  | public_seed | A public seed.

Definition at line 17 of file xmss_wots_publickey.cpp.

References Botan::XMSS_Address::bytes(), Botan::XMSS_Hash::f(), Botan::XMSS_Address::Key_Mode, m_hash, m_wots_params, Botan::XMSS_Address::Mask_Mode, Botan::XMSS_Hash::prf(), Botan::XMSS_Address::set_hash_address(), Botan::XMSS_Address::set_key_mask_mode(), Botan::XMSS_WOTS_Parameters::wots_parameter(), and Botan::xor_buf().

Referenced by Botan::XMSS_WOTS_PrivateKey::generate_public_key(), and Botan::XMSS_WOTS_PrivateKey::sign().

22 {
23 for(size_t i = start_idx;
24 i < (start_idx + steps) && i < m_wots_params.wots_parameter();
25 i++)
26 {
27 adrs.set_hash_address(i);
28
29 //Calculate tmp XOR bitmask
30 adrs.set_key_mask_mode(XMSS_Address::Key_Mask::Mask_Mode);
31 xor_buf(result, m_hash.prf(seed, adrs.bytes()), result.size());
32
33 // Calculate key
34 adrs.set_key_mask_mode(XMSS_Address::Key_Mask::Key_Mode);
35
36 //Calculate f(key, tmp XOR bitmask)
37 m_hash.f(result, m_hash.prf(seed, adrs.bytes()), result);
38 }
39 }
Botan::xor_buf
void xor_buf(T out[], const T in[], size_t length)
Definition: mem_ops.h:115
Botan::XMSS_Hash::f
void f(secure_vector< uint8_t > &result, const secure_vector< uint8_t > &key, const secure_vector< uint8_t > &data)
Definition: xmss_hash.h:74
Botan::XMSS_Hash::prf
void prf(secure_vector< uint8_t > &result, const secure_vector< uint8_t > &key, const secure_vector< uint8_t > &data)
Definition: xmss_hash.h:38
Botan::XMSS_WOTS_Parameters::wots_parameter
size_t wots_parameter() const
Definition: xmss_wots_parameters.h:95
Botan::XMSS_WOTS_PublicKey::m_hash
XMSS_Hash m_hash
Definition: xmss_wots_publickey.h:302
Botan::XMSS_Address::Key_Mask::Mask_Mode
Botan::XMSS_WOTS_PublicKey::m_wots_params
XMSS_WOTS_Parameters m_wots_params
Definition: xmss_wots_publickey.h:301
Botan::XMSS_Address::Key_Mask::Key_Mode

virtual bool Botan::XMSS_WOTS_PublicKey::check_key | ( | RandomNumberGenerator & | rng,
|  | bool | strong
| ) |  | const
| inline override virtual

Test the key values for consistency.

Parameters

  rng | rng to use
  strong | whether to perform strong and lengthy version of the test

Returns
  true if the test is passed

Implements Botan::Public_Key.

Definition at line 244 of file xmss_wots_publickey.h.

Referenced by Botan::XMSS_WOTS_Addressed_PublicKey::check_key().

245 {
246 return true;
247 }

std::unique_ptr< PK_Ops::Encryption > Botan::Public_Key::create_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return an encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::RSA_PublicKey, and Botan::ElGamal_PublicKey.

Definition at line 79 of file pk_keys.cpp.

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_Encryptor_EME::PK_Encryptor_EME().

82 {
83 throw Lookup_Error(algo_name() + " does not support encryption");
84 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

std::unique_ptr< PK_Ops::KEM_Encryption > Botan::Public_Key::create_kem_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a KEM encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::RSA_PublicKey, and Botan::McEliece_PublicKey.

Definition at line 87 of file pk_keys.cpp.

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_KEM_Encryptor::PK_KEM_Encryptor().

90 {
91 throw Lookup_Error(algo_name() + " does not support KEM encryption");
92 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

std::unique_ptr< PK_Ops::Verification > Botan::XMSS_WOTS_PublicKey::create_verification_op | ( | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| override virtual

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a verification operation for this key/params or throw

Parameters

  params | additional parameters
  provider | the provider to use

Reimplemented from Botan::Public_Key.

Definition at line 68 of file xmss_wots_publickey.cpp.

References algo_name().

Referenced by Botan::XMSS_WOTS_Addressed_PublicKey::create_verification_op().

70 {
71 if(provider == "base" || provider.empty())
72 {
73 return std::unique_ptr<PK_Ops::Verification>(
74 new XMSS_WOTS_Verification_Operation(*this));
75 }
76 throw Provider_Not_Found(algo_name(), provider);
77 }
Botan::XMSS_WOTS_PublicKey::algo_name
virtual std::string algo_name() const override
Definition: xmss_wots_publickey.h:234

virtual size_t Botan::XMSS_WOTS_PublicKey::estimated_strength | ( |  | ) | const
| inline override virtual

Return the estimated strength of the underlying key against the best currently known attack. Note that this ignores anything but pure attacks against the key itself and do not take into account padding schemes, usage mistakes, etc which might reduce the strength. However it does suffice to provide an upper bound.

Returns
  estimated strength in bits

Implements Botan::Public_Key.

Definition at line 253 of file xmss_wots_publickey.h.

Referenced by Botan::XMSS_WOTS_Addressed_PublicKey::estimated_strength(), and Botan::XMSS_WOTS_Addressed_PublicKey::key_length().

254 {
255 return m_wots_params.estimated_strength();
256 }
Botan::XMSS_WOTS_Parameters::estimated_strength
size_t estimated_strength() const
Definition: xmss_wots_parameters.h:107
Botan::XMSS_WOTS_PublicKey::m_wots_params
XMSS_WOTS_Parameters m_wots_params
Definition: xmss_wots_publickey.h:301

OID Botan::Public_Key::get_oid | ( |  | ) | const
| virtual inherited

Get the OID of the underlying public key scheme.

Returns
  OID of the public key scheme

Reimplemented in Botan::XMSS_WOTS_Addressed_PublicKey.

Definition at line 30 of file pk_keys.cpp.

References Botan::Public_Key::algo_name(), and Botan::OIDS::lookup().

Referenced by Botan::DL_Scheme_PublicKey::algorithm_identifier(), Botan::Curve25519_PublicKey::algorithm_identifier(), Botan::McEliece_PublicKey::algorithm_identifier(), Botan::RSA_PublicKey::algorithm_identifier(), Botan::GOST_3410_PublicKey::algorithm_identifier(), Botan::EC_PublicKey::algorithm_identifier(), Botan::TPM_PrivateKey::algorithm_identifier(), and Botan::XMSS_WOTS_Addressed_PublicKey::get_oid().

31 {
32 try {
33 return OIDS::lookup(algo_name());
34 }
35 catch(Lookup_Error&)
36 {
37 throw Lookup_Error("PK algo " + algo_name() + " has no defined OIDs");
38 }
39 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0
Botan::OIDS::lookup
std::string lookup(const OID &oid)
Definition: oids.cpp:18

const wots_keysig_t& Botan::XMSS_WOTS_PublicKey::key_data | ( |  | ) | const
| inline

Definition at line 215 of file xmss_wots_publickey.h.

References m_key.

Referenced by Botan::XMSS_WOTS_Verification_Operation::is_valid_signature().

215 { return m_key; }
Botan::XMSS_WOTS_PublicKey::m_key
wots_keysig_t m_key
Definition: xmss_wots_publickey.h:304

wots_keysig_t& Botan::XMSS_WOTS_PublicKey::key_data | ( |  | ) |
| inline

Definition at line 217 of file xmss_wots_publickey.h.

References m_key.

217 { return m_key; }
Botan::XMSS_WOTS_PublicKey::m_key
wots_keysig_t m_key
Definition: xmss_wots_publickey.h:304

virtual size_t Botan::XMSS_WOTS_PublicKey::key_length | ( |  | ) | const
| inline override virtual

Return an integer value best approximating the length of the primary security parameter. For example for RSA this will be the size of the modulus, for ECDSA the size of the ECC group, and for McEliece the size of the code will be returned.

Implements Botan::Public_Key.

Definition at line 258 of file xmss_wots_publickey.h.

259 {
260 return m_wots_params.estimated_strength();
261 }
Botan::XMSS_WOTS_Parameters::estimated_strength
size_t estimated_strength() const
Definition: xmss_wots_parameters.h:107
Botan::XMSS_WOTS_PublicKey::m_wots_params
XMSS_WOTS_Parameters m_wots_params
Definition: xmss_wots_publickey.h:301

virtual size_t Botan::Public_Key::message_part_size | ( |  | ) | const
| inline virtual inherited

Returns how large each of the message parts refered to by message_parts() is

This function is public but applications should have few reasons to ever call this.

Returns
  size of the message parts in bits

Reimplemented in Botan::GOST_3410_PublicKey, Botan::ECDSA_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, and Botan::DSA_PublicKey.

Definition at line 114 of file pk_keys.h.

Referenced by Botan::PK_Signer::PK_Signer(), and Botan::PK_Verifier::PK_Verifier().

114 { return 0; }

virtual size_t Botan::Public_Key::message_parts | ( |  | ) | const
| inline virtual inherited

Returns more than 1 if the output of this algorithm (ciphertext, signature) should be treated as more than one value. This is used for algorithms like DSA and ECDSA, where the (r,s) output pair can be encoded as either a plain binary list or a TLV tagged DER encoding depending on the protocol.

This function is public but applications should have few reasons to ever call this.

Returns
  number of message parts

Reimplemented in Botan::GOST_3410_PublicKey, Botan::ECDSA_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, and Botan::DSA_PublicKey.

Definition at line 103 of file pk_keys.h.

Referenced by Botan::X509_Object::check_signature(), Botan::choose_sig_format(), Botan::PK_Signer::PK_Signer(), and Botan::PK_Verifier::PK_Verifier().

103 { return 1; }

Botan::XMSS_WOTS_PublicKey::operator const wots_keysig_t & | ( |  | ) | const
| inline

Convert the key into the raw key data. The key becomes a length len vector of n-byte elements.

Definition at line 193 of file xmss_wots_publickey.h.

References m_key.

193 { return m_key; }
Botan::XMSS_WOTS_PublicKey::m_key
wots_keysig_t m_key
Definition: xmss_wots_publickey.h:304

Botan::XMSS_WOTS_PublicKey::operator wots_keysig_t & | ( |  | ) |
| inline

Convert the key into the raw key data. The key becomes a length len vector of n-byte elements.

Definition at line 199 of file xmss_wots_publickey.h.

References m_key.

199 { return m_key; }
Botan::XMSS_WOTS_PublicKey::m_key
wots_keysig_t m_key
Definition: xmss_wots_publickey.h:304

bool Botan::XMSS_WOTS_PublicKey::operator!= | ( | const XMSS_WOTS_PublicKey & | key | ) |
| inline

Definition at line 273 of file xmss_wots_publickey.h.

274 {
275 return !(*this == key);
276 }

bool Botan::XMSS_WOTS_PublicKey::operator== | ( | const XMSS_WOTS_PublicKey & | key | ) |
| inline

Definition at line 268 of file xmss_wots_publickey.h.

References m_key, and m_key.

269 {
270 return m_key == key.m_key;
271 }
Botan::XMSS_WOTS_PublicKey::m_key
wots_keysig_t m_key
Definition: xmss_wots_publickey.h:304

const secure_vector<uint8_t>& Botan::XMSS_WOTS_PublicKey::operator[] | ( | size_t | i | ) | const
| inline

Retrieves the i-th element out of the length len chain of n-byte elements contained in the public key.

Parameters

  i | index of the element.

Returns
  n-byte element addressed by i.

Definition at line 186 of file xmss_wots_publickey.h.

References m_key.

186 { return m_key[i]; }
Botan::XMSS_WOTS_PublicKey::m_key
wots_keysig_t m_key
Definition: xmss_wots_publickey.h:304

secure_vector<uint8_t>& Botan::XMSS_WOTS_PublicKey::operator[] | ( | size_t | i | ) |
| inline

Definition at line 187 of file xmss_wots_publickey.h.

References m_key.

187 { return m_key[i]; }
Botan::XMSS_WOTS_PublicKey::m_key
wots_keysig_t m_key
Definition: xmss_wots_publickey.h:304

virtual std::vector<uint8_t> Botan::XMSS_WOTS_PublicKey::public_key_bits | ( |  | ) | const
| inline override virtual

Returns
  BER encoded public key bits

Implements Botan::Public_Key.

Definition at line 263 of file xmss_wots_publickey.h.

Referenced by Botan::XMSS_WOTS_Addressed_PublicKey::public_key_bits().

264 {
265 throw Not_Implemented("No key format defined for XMSS-WOTS");
266 }

const secure_vector<uint8_t>& Botan::XMSS_WOTS_PublicKey::public_seed | ( |  | ) | const
| inline

Definition at line 201 of file xmss_wots_publickey.h.

Referenced by Botan::XMSS_WOTS_PrivateKey::generate_public_key(), and Botan::XMSS_WOTS_Verification_Operation::is_valid_signature().

201 { return m_public_seed; }
Botan::XMSS_WOTS_PublicKey::m_public_seed
secure_vector< uint8_t > m_public_seed
Definition: xmss_wots_publickey.h:305

secure_vector<uint8_t>& Botan::XMSS_WOTS_PublicKey::public_seed | ( |  | ) |
| inline

Definition at line 203 of file xmss_wots_publickey.h.

203 { return m_public_seed; }
Botan::XMSS_WOTS_PublicKey::m_public_seed
secure_vector< uint8_t > m_public_seed
Definition: xmss_wots_publickey.h:305

void Botan::XMSS_WOTS_PublicKey::set_key_data | ( | const wots_keysig_t & | key_data | ) |
| inline

Definition at line 219 of file xmss_wots_publickey.h.

References m_key.

Referenced by Botan::XMSS_WOTS_PrivateKey::generate_public_key().

220 {
221 m_key = key_data;
222 }
Botan::XMSS_WOTS_PublicKey::m_key
wots_keysig_t m_key
Definition: xmss_wots_publickey.h:304
Botan::XMSS_WOTS_PublicKey::key_data
const wots_keysig_t & key_data() const
Definition: xmss_wots_publickey.h:215

void Botan::XMSS_WOTS_PublicKey::set_key_data | ( | wots_keysig_t && | key_data | ) |
| inline

Definition at line 224 of file xmss_wots_publickey.h.

References m_key.

225 {
226 m_key = std::move(key_data);
227 }
Botan::XMSS_WOTS_PublicKey::m_key
wots_keysig_t m_key
Definition: xmss_wots_publickey.h:304
Botan::XMSS_WOTS_PublicKey::key_data
const wots_keysig_t & key_data() const
Definition: xmss_wots_publickey.h:215

void Botan::XMSS_WOTS_PublicKey::set_public_seed | ( | const secure_vector< uint8_t > & | public_seed | ) |
| inline

Definition at line 205 of file xmss_wots_publickey.h.

206 {
207 m_public_seed = public_seed;
208 }
Botan::XMSS_WOTS_PublicKey::m_public_seed
secure_vector< uint8_t > m_public_seed
Definition: xmss_wots_publickey.h:305
Botan::XMSS_WOTS_PublicKey::public_seed
const secure_vector< uint8_t > & public_seed() const
Definition: xmss_wots_publickey.h:201

void Botan::XMSS_WOTS_PublicKey::set_public_seed | ( | secure_vector< uint8_t > && | public_seed | ) |
| inline

Definition at line 210 of file xmss_wots_publickey.h.

211 {
212 m_public_seed = std::move(public_seed);
213 }
Botan::XMSS_WOTS_PublicKey::m_public_seed
secure_vector< uint8_t > m_public_seed
Definition: xmss_wots_publickey.h:305
Botan::XMSS_WOTS_PublicKey::public_seed
const secure_vector< uint8_t > & public_seed() const
Definition: xmss_wots_publickey.h:201

std::vector< uint8_t > Botan::Public_Key::subject_public_key | ( |  | ) | const
| inherited

Returns
  X.509 subject key encoding for this key object

Definition at line 17 of file pk_keys.cpp.

References Botan::Public_Key::algorithm_identifier(), Botan::BIT_STRING, Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), Botan::DER_Encoder::get_contents_unlocked(), Botan::Public_Key::public_key_bits(), Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

Referenced by Botan::X509::BER_encode(), and Botan::X509::PEM_encode().

18 {
19 return DER_Encoder()
20 .start_cons(SEQUENCE)
21 .encode(algorithm_identifier())
22 .encode(public_key_bits(), BIT_STRING)
23 .end_cons()
24 .get_contents_unlocked();
25 }
Botan::Public_Key::public_key_bits
virtual std::vector< uint8_t > public_key_bits() const =0
Botan::Public_Key::algorithm_identifier
virtual AlgorithmIdentifier algorithm_identifier() const =0
Botan::SEQUENCE
Definition: asn1_obj.h:39
Botan::BIT_STRING
Definition: asn1_obj.h:34

const XMSS_WOTS_Parameters& Botan::XMSS_WOTS_PublicKey::wots_parameters | ( |  | ) | const
| inline

Definition at line 229 of file xmss_wots_publickey.h.

Referenced by Botan::XMSS_WOTS_PrivateKey::generate_public_key(), Botan::XMSS_WOTS_Verification_Operation::is_valid_signature(), Botan::XMSS_PrivateKey::tree_hash(), Botan::XMSS_WOTS_Verification_Operation::update(), Botan::XMSS_WOTS_Signature_Operation::update(), Botan::XMSS_WOTS_Signature_Operation::XMSS_WOTS_Signature_Operation(), and Botan::XMSS_WOTS_Verification_Operation::XMSS_WOTS_Verification_Operation().

230 {
231 return m_wots_params;
232 }
Botan::XMSS_WOTS_PublicKey::m_wots_params
XMSS_WOTS_Parameters m_wots_params
Definition: xmss_wots_publickey.h:301

## Member Data Documentation

XMSS_Hash Botan::XMSS_WOTS_PublicKey::m_hash
| protected

Definition at line 302 of file xmss_wots_publickey.h.

Referenced by chain().

wots_keysig_t Botan::XMSS_WOTS_PublicKey::m_key
| protected

Definition at line 304 of file xmss_wots_publickey.h.

Referenced by operator==().

secure_vector<uint8_t> Botan::XMSS_WOTS_PublicKey::m_public_seed
| protected

Definition at line 305 of file xmss_wots_publickey.h.

Referenced by Botan::XMSS_WOTS_PrivateKey::sign().

XMSS_WOTS_Parameters Botan::XMSS_WOTS_PublicKey::m_wots_params
| protected

Definition at line 301 of file xmss_wots_publickey.h.

Referenced by chain(), Botan::XMSS_WOTS_PrivateKey::generate_public_key(), and Botan::XMSS_WOTS_PrivateKey::sign().

The documentation for this class was generated from the following files:

- src/lib/pubkey/xmss/xmss_wots_publickey.h
- src/lib/pubkey/xmss/xmss_wots_publickey.cpp